/*
 * Created on 01 de abril de 2007, 20:25
 * lalbernaz@gmail.com
 */

import java.rmi.*;
import java.net.MalformedURLException;
import java.rmi.registry.*;
import java.rmi.RMISecurityManager;
import java.io.*;

public class Proc {
    
 
    /** Mtodo principal do "processo". */
    public static void main(String args[]){
        
        int num1, num2;
        char oper;
        double resultado;
        
        try{
            //Definir o security manager;
            if(System.getSecurityManager() == null){
                System.setSecurityManager(new RMISecurityManager());
            }  
            
            //Cria referncia para o servidor remoto.
            System.out.println("Registrando-se no servidor...");            
            Remote referenciaRemota = Naming.lookup("servidor");                
            InterfaceServidor a = (InterfaceServidor) referenciaRemota;
            
            //Cria objeto de leitura do console (teclado);
            BufferedReader teclado = new BufferedReader(new InputStreamReader(System.in));            
            
            //Cria interface com console (teclado) e l dados do console (teclado);
            System.out.println("Sequencia esperada: Num1 (inteiro) + operador (+, -, ., /) + Num2 (inteiro)");
            System.out.print("\nNum1 > " );
            num1 = Integer.parseInt(teclado.readLine());
            System.out.print("Oper > " );
            oper = teclado.readLine().charAt(0);
            System.out.print("Num2 > " );
            num2 = Integer.parseInt(teclado.readLine());            
            
            //Envia dados lidos do console (teclado) para o servidor atravs do canal de sada e recebe o resultado do servidor;
            resultado = a.calculaOperacao(num1, oper, num2);
            System.out.println("----------");
            System.out.println("resultado > " + resultado);

        }
        catch(MalformedURLException e) {
            System.out.println();
            System.out.println( "MalformedURLException: " + e.toString() );
        }
        catch(RemoteException e) {
            System.out.println();
            System.out.println( "RemoteException: " + e.toString() );
        }
        catch(NotBoundException e) {
            System.out.println();
            System.out.println( "NotBoundException: " + e.toString() );
        }
        catch(Exception e) {
            System.out.println();
            System.out.println( "Exception: " + e.toString() );
        }
        
    }
    
}
