/*
 * Created on 01 de abril de 2007, 20:20
 * lalbernaz@gmail.com
 */

import java.rmi.*;
import java.rmi.registry.*;
import java.net.MalformedURLException;
import java.rmi.RMISecurityManager;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

public class Servidor extends UnicastRemoteObject implements InterfaceServidor{
    
    /** Mtodo construtor */
    public Servidor() throws RemoteException{
        super();        
    }
  
    /** Interface implementada para mtodo remoto */
    public double calculaOperacao(int num1, char oper, int num2) throws RemoteException{            
            
        double resultado = 0.0;                
        switch(oper){
            case '+':
                resultado = num1 + num2;
                break;
            case '-':
                resultado = num1 - num2;
                break;
            case '.':
                resultado = num1 * num2;
                break;
            case '/':
                resultado = num1 / num2;
                break;
        }
        return resultado;
        
    }    
    
    
    /** Mtodo principal do Servidor. Chama o mtodo construtor da classe */
    public static void main(String args[]) throws RemoteException{               
        
        try {            
            //Definir o security manager;
            if(System.getSecurityManager() == null){
                System.setSecurityManager(new RMISecurityManager());
            }                        
            
            System.out.println("Construindo as implementacoes do Servidor...");            
            Servidor servidor = new Servidor();
            System.out.println("Registrando as implementacoes...");
            Naming.rebind("servidor", servidor);                        
            System.out.println("Servidor iniciado!");
            
            //System.exit(0);
            
        }
        catch( Exception e ) {
            System.out.println( "Problema: " + e );
        }
        
    }
    
}
