/*
 * Created on 01 de abril de 2007, 20:25
 * lalbernaz@gmail.com
 */

import java.rmi.*;
import java.net.MalformedURLException;
import java.rmi.registry.*;
import java.rmi.RMISecurityManager;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.io.*;


public class Proc extends UnicastRemoteObject implements InterfaceProc{
    
       
    /** Mtodo construtor */
    public Proc() throws RemoteException{        
        super();        
    }
    
    
    public void atribuiMensagem(String _msgm) throws RemoteException{                
        System.out.println(_msgm);
    }    
    
 
    /** Mtodo principal do "processo". */
    public static void main(String args[]) throws RemoteException{
        
        int num1, num2, idCliente;
        char oper;
        double resultado;
        String msgmDigitada;
        
        try{
            
            //Disponibiliza os servios do cliente;
            System.setSecurityManager(new RMISecurityManager());            
            //System.out.println("Construindo as implementacoes do Cliente...");
            Proc cliente = new Proc();
            //System.out.println("Registrando as implementacoes...");
            Naming.rebind("cliente", cliente);
            //System.out.println("Cliente iniciado!");

            //Busca referncia dos servios do servidor;
            //System.out.println("Registrando-se no servidor...");            
            Remote referenciaRemota = Naming.lookup("servidor");                
            InterfaceServidor a = (InterfaceServidor) referenciaRemota;
            
            idCliente = a.estabeleceConexao();
            System.out.println("Id do cliente: " + idCliente);
            
            //Cria objeto de leitura do console (teclado);
            BufferedReader teclado = new BufferedReader(new InputStreamReader(System.in));
            
            //Loop para cliente ficar lendo do teclado e enviando para todos;
            System.out.print("Entre com um nome: ");
            String nome = teclado.readLine();  
            msgmDigitada = teclado.readLine();            
            while(msgmDigitada.compareTo("end") != 0){
                a.sendoToAll(msgmDigitada, idCliente, nome);            
                msgmDigitada = teclado.readLine();
            }
            
            System.out.print("Saiu...");
            System.out.println(a.liberaConexao(idCliente));
            System.exit(1);
            
        }catch(Exception e) {         
            System.out.println( "Exception: " + e.toString() );
        }
        
    }
    
}
