/*
 * Created on 01 de abril de 2007, 20:20
 * lalbernaz@gmail.com
 */

import java.rmi.*;
import java.rmi.registry.*;
import java.net.MalformedURLException;
import java.rmi.RMISecurityManager;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.util.*;


public class Servidor extends UnicastRemoteObject implements InterfaceServidor{    
    
    /** Estrutura para armazenar o ID dos clientes conectados no chat */    
    InterfaceProc clientesConectados[];
    
    
    /** Determinar que o primeiro cliente ter o ID 1 */
    static int idCliente = 0;    
    
        
    /** Mtodo construtor */
    public Servidor() throws RemoteException{
        super();                
        clientesConectados = new InterfaceProc[20];
    }  

    
    public int estabeleceConexao() throws RemoteException{                
        idCliente ++;
        
        try{                        
            //Busca referncia dos servios do clientes;
            //System.out.println("Registrando-se no cliente...");            
            clientesConectados[idCliente] = (InterfaceProc) Naming.lookup("cliente");
            
        }catch(Exception e) {            
            System.out.println( "Exception: " + e.toString() );
        }
        
        return idCliente;
    }    
    
    
    public String liberaConexao(int _idCliente) throws RemoteException{        
        
        //Loop para excluir usurio do chat;
        for(int i = 0; i < clientesConectados.length; i++){
            if(i == _idCliente){
                clientesConectados[idCliente] = null;
            }            
        }
        //System.out.println("clientesConectados: " + (idCliente - 1) + " - clienteQueSaiu: " + _idCliente);
        idCliente --;
        
        return "Conexao liberada!";
    }    
    
    
    public void sendoToAll(String _msgm, int _idCliente, String _nome) throws RemoteException{        
        
        //Envia mensagem para todos menos para o "_idCliente";
        for(int i = 0; i < clientesConectados.length; i++){
            if((clientesConectados[i] != null) && (i != _idCliente)){                
                clientesConectados[i].atribuiMensagem("> " + _nome + " disse: " + _msgm);
            }
        }
        
    }
    
    
    /** Mtodo principal do Servidor. Chama o mtodo construtor da classe */
    public static void main(String args[]) throws RemoteException{               
        
        try {
            //Disponibiliza os servios do servidor; 
            System.setSecurityManager(new RMISecurityManager());            
            System.out.println("Construindo as implementacoes do Servidor...");            
            Servidor servidor = new Servidor();
            System.out.println("Registrando as implementacoes...");
            Naming.rebind("servidor", servidor);                        
            System.out.println("Servidor iniciado!");
                        
            //System.exit(0);
            
        }
        catch( Exception e ) {
            System.out.println( "Problema: " + e );
        }
        
    }
    
}
