/*
 * CalcServer.java
 *
 * Created on 31 de Maro de 2007, 11:07
 */

import java.io.*;
import java.net.*;
import java.util.*;



public class CalcServer extends Thread{
    
    private static ServerSocket ss = null;
    private static Socket conexao = null;    
    
    public CalcServer(Socket _s) {
        this.conexao = _s;
    }
    
    public void run(){        
        
        int num1, num2;
        char oper;
        double resultado;
        
        try{         
            
            //Cria objetos que controlam o fluxo de comunicao;            
            DataInputStream in = new DataInputStream(conexao.getInputStream());
            DataOutputStream out = new DataOutputStream(conexao.getOutputStream());            
            
            //Recebe valores a serem calculados;
            num1 = in.readInt();                                    
            oper = in.readChar();           
            num2 = in.readInt();            
            
            //Calcula o resultado da operao desejada pelo cliente;
            resultado = calculaValor(num1, oper, num2);
            
            //Envia para o cliente o resultado da operao;
            out.writeDouble(resultado);            
            
            //Encerra os canais de comunicao e o socket com o cliente;
            in.close();
            out.close();
            conexao.close();
            
        }catch(IOException e){
            System.out.println("IOException: " + e);            
        }
        
    }
    
    //Recebe os valos recebidos do cliente e retorna o double com o resultado;
    public double calculaValor(int _num1, char _oper, int _num2){        
        
        double _resultado = 0.0;                
        switch(_oper){
            case '+':
                _resultado = _num1 + _num2;
                break;
            case '-':
                _resultado = _num1 - _num2;
                break;
            case '.':
                _resultado = _num1 * _num2;
                break;
            case '/':
                _resultado = _num1 / _num2;
                break;
        }        
        return _resultado;
        
    }
    
    public static void main(String args[]){
        
        try{                        
            //Cria o ServerSockets;
            ss = new ServerSocket(5000);                                            
            while(true){                
                System.out.println("Esperando conexao do cliente...");
                //Cria o Socket e espera por conexes;
                Socket s = ss.accept();                                
                //Cria Thread para socket com um cliente. Passa o socket estabelecido para o mtodo construtor;
                Thread t = new CalcServer(s);
                t.start();                
                //Volta ao loop para esperar mais concexes;
            }                       
            
        }catch(IOException e){
            System.out.println("IOException: " + e);
            System.exit(1);
        }
        
        
    }
    
    
}
