/*
 * Created on 30 de Maro de 2007, 19:13
 * @author user
 */

import java.io.*;
import java.net.*;


public class ChatCliente extends Thread{
    
    //Flag que indica quando se deve terminar a execuo;
    private static boolean done = false;
    
    //parte que controla a recepo de mensagens deste cliente;
    private Socket conexao; 
    
    //construtor que recebe o socket deste cliente;
    public ChatCliente(Socket s) {
        conexao = s;
    }
    
    //execuo da thread;
    public void run(){
        
        try {
            BufferedReader entrada = new BufferedReader(new InputStreamReader(conexao.getInputStream()));
            String linha;
            
            while(true){                
                
                //pega o que o servidor enviou;
                linha = entrada.readLine();
                
                //verifica se  uma linha vlida. Pode ser que a conexo foi interrompida. Neste caso, a 
                //linha  null. Se isso ocorrer, termina-se a execuo saindo com break;

                if(linha == null){
                    System.out.println("Conexao encerrada!");
                    break;
                }

                //caso a linha no seja nula, deve-se imprimi-la;
                System.out.println();
                System.out.println(linha);
                //System.out.print("...> ");
            }
            
        }catch(IOException e){
            //caso ocorra alguma exceo de E/S, mostre qual foi;
            System.out.println("IOException: " + e);
        }
        
        //sinaliza para o main que a conexo encerrou;
        done = true;
    }
    
    public static void main(String args[]){
        
        try{            
            
            Socket conexao = new Socket("LocalHost", 5000);

            //Criar os objetos que permitem controlar o fluxo de comunicao;
            PrintStream saida = new PrintStream(conexao.getOutputStream());

            //enviar antes de tudo o nome do usurio;
            BufferedReader teclado = new BufferedReader(new InputStreamReader(System.in));
            System.out.print("Entre com o seu nome: ");
            String NomeCliente = teclado.readLine();
            saida.println(NomeCliente);

            //uma vez que tudo est pronto, antes de iniciar o loop principal, executar a thread 
            //de recepo de mensagens;
            Thread t = new ChatCliente(conexao);
            t.start();

            //loop principal: obtendo uma linha digitada no teclado e enviando-a para o servidor;
            String linha;

            while(true){
                // ler a linha digitada no teclado
                System.out.print("> ");
                linha = teclado.readLine();
                // antes de enviar, verifica se a conexo no foi fechada
                if(done){
                    break;
                }
                // envia para o servidor
                saida.println(linha);
            }

        }catch(IOException e){
            // Caso ocorra alguma excesso de E/S, mostre qual foi.
            System.out.println("IOException: " + e);
        }
        
    }

 
}
