/*
 * Created on 30 de Maro de 2007, 15:33
 * @author user
 */

import java.io.*;
import java.net.*;
import java.util.*;

public class ChatServer extends Thread{
    
    //Estrutura usada para armazenar os sockets de todos os clientes;
    private static Vector clientes;    
    private Socket conexao;    
    private String nomeDoCliente;
    
    //construtor que recebe o socket do cliente criado no mtodo main();
    public ChatServer(Socket s){
        conexao = s;        
    }
        
    public void run(){
    
        try{
            //Cria objetos que controlam o fluxo de comunicao;
            BufferedReader in = new BufferedReader(new InputStreamReader(conexao.getInputStream()));
            PrintStream out = new PrintStream(conexao.getOutputStream());
            
            //Espera no canal de entrada que o cliente envie seu nome para entrar no char;
            nomeDoCliente = in.readLine();
            
            //verifica se o nome  vlido. Se for null,  pq a conexo foi interrompida;
            if(nomeDoCliente == null){
                return;
            }
            
            //Uma vez que se tem um cliente conectado e conhecido, coloca-se o canal de sada para esse
            //cliente no vetor de clientes conectados;
            clientes.add(out);
            
            //clientes  um objeto compartilhado por vrias threads. Os mtodos so sincronizados, portanto,
            //no h problemas de acesso simultneo. Espera-se por alguma string do cliente. Quando recebe, 
            //envia a todos os conectados at que o cliente envie linha em branco;
            String linha = in.readLine();
            
            //Verifica-se se linha recebida no  null;
            while(linha != null && !(linha.trim().equals(""))){
                //reenvia a linha para todos os clientes conectados;
                sendToAll(out, " disse: ", linha);
                //espera por uma nova linha;
                linha = in.readLine();
            }
            
            //Uma vez que o cliente enviou linha em branco, retira-se o fluxo de sada do vetor
            //e fecha-se a conexo;
            sendToAll(out, " saiu ", "do chat!");
            clientes.remove(out);
            conexao.close();
            
        }catch(IOException e){
            System.out.println("IOException: " + e);
        }
        
    }
        
    public void sendToAll(PrintStream saida, String acao, String linha) throws IOException{
        
        Enumeration e = clientes.elements();
        
        while(e.hasMoreElements()){
            //obtem o fluxo de sada de um dos clientes;
            PrintStream chat = (PrintStream)e.nextElement();
            //envia para todos menos para o prprio usurio;
            if(chat != saida){
                chat.println(nomeDoCliente + acao + linha);
            }
        }
        
    }
    
    public static void main(String args[]){
        
        //Cria a estrutura para armanezar os sockets de cada cliente;
        clientes = new Vector();
        
        try{            
            ServerSocket ss = new ServerSocket(5000);                        
            while(true){            
                System.out.println("Esperando algum se conectar...");
                Socket s = ss.accept();
                System.out.println("Cliente conectado...");
                
                //Cria uma nova Thread para tratar essa conexo;
                Thread t = new ChatServer(s);
                t.start();
                //Volta ao loop para esperar mais concexes;
            }            
        }catch(IOException e){
            System.out.println("IOException: " + e);
        }
        
    }
    
    
}
